#ifndef _SUZAKU_SPI_H_
#define _SUZAKU_SPI_H_

#define SPI_TIMEOUT 20 //[s]

/* opb spi registers */
#define REG_IPIF_SOFT_RESET       (0x40)
#define REG_SPICR                 (0x60)
#define     SPICR_MTI             (1<<8)
#define     SPICR_MSSSAE          (1<<7)
#define     SPICR_RX_FIFO_RESET   (1<<6)
#define     SPICR_TX_FIFO_RESET   (1<<5)
#define     SPICR_CPHA            (1<<4)
#define     SPICR_CPOL            (1<<3)
#define     SPICR_MASTER          (1<<2)
#define     SPICR_SPE             (1<<1)
#define     SPICR_LOOP            (1<<0)
#define REG_SPISR                 (0x64)
#define     SPISR_MODF            (1<<4)
#define     SPISR_TX_FULL         (1<<3)
#define     SPISR_TX_EMPTY        (1<<2)
#define     SPISR_RX_FULL         (1<<1)
#define     SPISR_RX_EMPTY        (1<<0)
#define REG_SPIDTR                (0x68)
#define REG_SPIDRR                (0x6C)
#define REG_SPISSR                (0x70)
#define REG_TX_FIFO_OCY           (0x74)
#define REG_RX_FIFO_OCY           (0x78)

#define REG_DGIE                  (0x1C)
#define     DGIE_GIE              (1<<31)
#define REG_IPISR                 (0x20)
#define REG_IPIER                 (0x28)

/* spi instructions */
#define SPI_WRSR                      (0x01)
#define SPI_WRITE                     (0x02)
#define SPI_PP                        SPI_WRITE
#define SPI_READ                      (0x03)
#define SPI_WRDI                      (0x04)
#define SPI_RDSR                      (0x05)
#define SPI_WREN                      (0x06)
#define SPI_FAST_READ                 (0x0b)
#define SPI_PE                        (0x42)
#define SPI_RDID                      (0x9f)
#define SPI_RDSR_WIP                  (1<<0)
#define SPI_RDSR_WEL                  (1<<1)
#define SPI_RDSR_BP0                  (1<<2)
#define SPI_RDSR_BP1                  (1<<3)
#define SPI_RDSR_BP2                  (1<<4)
#define SPI_RDSR_SRWD                 (1<<7)
#define SPI_RES                       (0xab)
//#define SPI_RDID                    SPI_RES //Microchip 25AAXXXX/25LCXXXX
#define SPI_DPD                       (0xb9)
#define SPI_BE                        (0xc7)
#define SPI_CE                        (0xce)
#define SPI_SE                        (0xd8)

/* Dummy byte */
#define SPI_DUMMY_BYTE                (0x00)

#endif
