/*
 * arch/ppc/platforms/4xx/virtex.h
 *
 * Include file that defines the Xilinx Virtex-II Pro processor
 *
 * Author: MontaVista Software, Inc.
 *         source@mvista.com
 *
 * 2002-2004 (c) MontaVista Software, Inc.  This file is licensed under the
 * terms of the GNU General Public License version 2.  This program is licensed
 * "as is" without any warranty of any kind, whether express or implied.
 */

#ifdef __KERNEL__
#ifndef __ASM_VIRTEX_H__
#define __ASM_VIRTEX_H__

/* serial defines */

#include <asm/ibm405.h>

/* Ugly, ugly, ugly! BASE_BAUD defined here to keep 8250.c happy. */
#if !defined(BASE_BAUD)
 #define BASE_BAUD		(0) /* dummy value; not used */
#endif
  
/* Device type enumeration for platform bus definitions */
#ifndef __ASSEMBLY__
enum ppc_sys_devices {
#if defined(CONFIG_SERIAL_8250)
	VIRTEX_UART,
#endif
#if defined(CONFIG_SERIAL_UARTLITE) || defined(CONFIG_SERIAL_UARTLITE_MODULE)
	UARTLITE_UART,
#endif
#if defined(CONFIG_XILINX_TEMAC) || defined(CONFIG_XILINX_TEMAC_MODULE) || \
    defined(CONFIG_XILINX_OLD_TEMAC) || defined(CONFIG_XILINX_OLD_TEMAC_MODULE) || \
    defined(CONFIG_PICO_TEMAC) || defined(CONFIG_PICO_TEMAC_MODULE)
 	VIRTEX_TEMAC_0,
#endif
	NUM_PPC_SYS_DEVS
};
#endif
  
#endif				/* __ASM_VIRTEX_H__ */
#endif				/* __KERNEL__ */
