/*
 * arch/ppc/platforms/4xx/xparameters/xparameters.h
 *
 * This file includes the correct xparameters.h for the CONFIG'ed board plus
 * fixups to translate board specific XPAR values to a common set of names
 *
 * Author: MontaVista Software, Inc.
 *         source@mvista.com
 *
 * 2004 (c) MontaVista Software, Inc.  This file is licensed under the terms
 * of the GNU General Public License version 2.  This program is licensed
 * "as is" without any warranty of any kind, whether express or implied.
 */

#include <linux/autoconf.h>

#if defined(CONFIG_XILINX_ML300)
  #include "xparameters_ml300.h"
#elif defined(CONFIG_XILINX_ML403)
  #include "xparameters_ml403.h"
#elif defined(CONFIG_SUZAKU_SZ310)
#if   !defined(CONFIG_SUZAKU_STARTERKIT) && \
      !defined(CONFIG_SUZAKU_SIL) && \
      !(defined(CONFIG_SUZAKU_SID) || defined(CONFIG_SUZAKU_SID_MODULE)) && \
      !(defined(CONFIG_SUZAKU_SIV) || defined(CONFIG_SUZAKU_SIV_MODULE) || \
        defined(CONFIG_SUZAKU_SIA) || defined(CONFIG_SUZAKU_SIA_MODULE))
  #include "xparameters_sz310.h"
#elif  defined(CONFIG_SUZAKU_STARTERKIT) && \
      !defined(CONFIG_SUZAKU_SIL) && \
      !(defined(CONFIG_SUZAKU_SID) || defined(CONFIG_SUZAKU_SID_MODULE)) && \
      !(defined(CONFIG_SUZAKU_SIV) || defined(CONFIG_SUZAKU_SIV_MODULE) || \
        defined(CONFIG_SUZAKU_SIA) || defined(CONFIG_SUZAKU_SIA_MODULE))
  #include "xparameters_sz310-starterkit.h"
#elif !defined(CONFIG_SUZAKU_STARTERKIT) && \
       defined(CONFIG_SUZAKU_SIL) && \
      !(defined(CONFIG_SUZAKU_SIV) || defined(CONFIG_SUZAKU_SIV_MODULE) || \
        defined(CONFIG_SUZAKU_SIA) || defined(CONFIG_SUZAKU_SIA_MODULE))
  #include "xparameters_sz310-sil.h"
#elif !defined(CONFIG_SUZAKU_STARTERKIT) && \
      !defined(CONFIG_SUZAKU_SIL) && \
       (defined(CONFIG_SUZAKU_SID) || defined(CONFIG_SUZAKU_SID_MODULE)) && \
      !(defined(CONFIG_SUZAKU_SIV) || defined(CONFIG_SUZAKU_SIV_MODULE) || \
        defined(CONFIG_SUZAKU_SIA) || defined(CONFIG_SUZAKU_SIA_MODULE))
  #include "xparameters_sz310-sid.h"
#else
  #error No xparameters_*.h file included
#endif
#elif defined(CONFIG_SUZAKU_SZ410)
#ifdef CONFIG_XILINX_TEMAC_PLB
#if   !defined(CONFIG_SUZAKU_STARTERKIT) && \
      !defined(CONFIG_SUZAKU_SIL) && \
      !(defined(CONFIG_SUZAKU_SID) || defined(CONFIG_SUZAKU_SID_MODULE)) && \
      !(defined(CONFIG_SUZAKU_SIV) || defined(CONFIG_SUZAKU_SIV_MODULE) || \
        defined(CONFIG_SUZAKU_SIA) || defined(CONFIG_SUZAKU_SIA_MODULE))
  #include "xparameters_sz410-plbtemac.h"
#elif  defined(CONFIG_SUZAKU_STARTERKIT) && \
      !defined(CONFIG_SUZAKU_SIL) && \
      !(defined(CONFIG_SUZAKU_SID) || defined(CONFIG_SUZAKU_SID_MODULE)) && \
      !(defined(CONFIG_SUZAKU_SIV) || defined(CONFIG_SUZAKU_SIV_MODULE) || \
        defined(CONFIG_SUZAKU_SIA) || defined(CONFIG_SUZAKU_SIA_MODULE))
  #include "xparameters_sz410-plbtemac-starterkit.h"
#elif !defined(CONFIG_SUZAKU_STARTERKIT) && \
       defined(CONFIG_SUZAKU_SIL) && \
      !(defined(CONFIG_SUZAKU_SID) || defined(CONFIG_SUZAKU_SID_MODULE)) && \
      !(defined(CONFIG_SUZAKU_SIV) || defined(CONFIG_SUZAKU_SIV_MODULE) || \
        defined(CONFIG_SUZAKU_SIA) || defined(CONFIG_SUZAKU_SIA_MODULE))
  #include "xparameters_sz410-plbtemac-sil.h"
#elif !defined(CONFIG_SUZAKU_STARTERKIT) && \
      !defined(CONFIG_SUZAKU_SIL) && \
       (defined(CONFIG_SUZAKU_SID) || defined(CONFIG_SUZAKU_SID_MODULE)) && \
      !(defined(CONFIG_SUZAKU_SIV) || defined(CONFIG_SUZAKU_SIV_MODULE) || \
        defined(CONFIG_SUZAKU_SIA) || defined(CONFIG_SUZAKU_SIA_MODULE))
  #include "xparameters_sz410-plbtemac-sid.h"
#else
  #error No xparameters_*.h file included
#endif
#else
#if   !defined(CONFIG_SUZAKU_STARTERKIT) && \
      !defined(CONFIG_SUZAKU_SIL) && \
      !(defined(CONFIG_SUZAKU_SID) || defined(CONFIG_SUZAKU_SID_MODULE)) && \
      !(defined(CONFIG_SUZAKU_SIV) || defined(CONFIG_SUZAKU_SIV_MODULE) || \
        defined(CONFIG_SUZAKU_SIA) || defined(CONFIG_SUZAKU_SIA_MODULE))
  #include "xparameters_sz410.h"
#elif  defined(CONFIG_SUZAKU_STARTERKIT) && \
      !defined(CONFIG_SUZAKU_SIL) && \
      !(defined(CONFIG_SUZAKU_SID) || defined(CONFIG_SUZAKU_SID_MODULE)) && \
      !(defined(CONFIG_SUZAKU_SIV) || defined(CONFIG_SUZAKU_SIV_MODULE) || \
        defined(CONFIG_SUZAKU_SIA) || defined(CONFIG_SUZAKU_SIA_MODULE))
  #include "xparameters_sz410-starterkit.h"
#elif !defined(CONFIG_SUZAKU_STARTERKIT) && \
       defined(CONFIG_SUZAKU_SIL) && \
      !(defined(CONFIG_SUZAKU_SID) || defined(CONFIG_SUZAKU_SID_MODULE)) && \
      !(defined(CONFIG_SUZAKU_SIV) || defined(CONFIG_SUZAKU_SIV_MODULE) || \
        defined(CONFIG_SUZAKU_SIA) || defined(CONFIG_SUZAKU_SIA_MODULE))
  #include "xparameters_sz410-sil.h"
#elif !defined(CONFIG_SUZAKU_STARTERKIT) && \
      !defined(CONFIG_SUZAKU_SIL) && \
       (defined(CONFIG_SUZAKU_SID) || defined(CONFIG_SUZAKU_SID_MODULE)) && \
      !(defined(CONFIG_SUZAKU_SIV) || defined(CONFIG_SUZAKU_SIV_MODULE) || \
        defined(CONFIG_SUZAKU_SIA) || defined(CONFIG_SUZAKU_SIA_MODULE))
  #include "xparameters_sz410-sid.h"
#elif !defined(CONFIG_SUZAKU_STARTERKIT) && \
      !defined(CONFIG_SUZAKU_SIL) && \
      !(defined(CONFIG_SUZAKU_SID) || defined(CONFIG_SUZAKU_SID_MODULE)) && \
       (defined(CONFIG_SUZAKU_SIV) || defined(CONFIG_SUZAKU_SIV_MODULE) || \
        defined(CONFIG_SUZAKU_SIA) || defined(CONFIG_SUZAKU_SIA_MODULE))
  #include "xparameters_sz410-siv.h"
#else
  #error No xparameters_*.h file included
#endif
#endif

#define XPAR_TEMAC_0_IP2INTC_IRPT_MASK XPAR_PLB_TEMAC_0_IP2INTC_IRPT_MASK

#ifdef CONFIG_XILINX_TEMAC_PLB
#define XPAR_SYSTEM_INTC_TEMAC_0_IP2INTC_IRPT_INTR XPAR_SYSTEM_INTC_PLB_TEMAC_0_IP2INTC_IRPT_INTR
#ifndef XPAR_TEMAC_0_DEVICE_ID
#define XPAR_TEMAC_0_DEVICE_ID XPAR_PLB_TEMAC_0_DEVICE_ID
#endif
#ifndef XPAR_TEMAC_0_BASEADDR
#define XPAR_TEMAC_0_BASEADDR XPAR_PLB_TEMAC_0_BASEADDR
#endif
#ifndef XPAR_TEMAC_0_HIGHADDR
#define XPAR_TEMAC_0_HIGHADDR XPAR_PLB_TEMAC_0_HIGHADDR
#endif
#ifndef XPAR_TEMAC_0_RXFIFO_DEPTH
#define XPAR_TEMAC_0_RXFIFO_DEPTH XPAR_PLB_TEMAC_0_RXFIFO_DEPTH
#endif
#ifndef XPAR_TEMAC_0_TXFIFO_DEPTH
#define XPAR_TEMAC_0_TXFIFO_DEPTH XPAR_PLB_TEMAC_0_TXFIFO_DEPTH
#endif
#ifndef XPAR_TEMAC_0_MAC_FIFO_DEPTH
#define XPAR_TEMAC_0_MAC_FIFO_DEPTH XPAR_PLB_TEMAC_0_MAC_FIFO_DEPTH
#endif
#ifndef XPAR_TEMAC_0_DMA_TYPE
#define XPAR_TEMAC_0_DMA_TYPE XPAR_PLB_TEMAC_0_DMA_TYPE
#endif
#ifndef XPAR_TEMAC_0_TX_DRE_TYPE
#define XPAR_TEMAC_0_TX_DRE_TYPE XPAR_PLB_TEMAC_0_TX_DRE_TYPE
#endif
#ifndef XPAR_TEMAC_0_RX_DRE_TYPE
#define XPAR_TEMAC_0_RX_DRE_TYPE XPAR_PLB_TEMAC_0_RX_DRE_TYPE
#endif
#ifndef XPAR_TEMAC_0_INCLUDE_TX_CSUM
#define XPAR_TEMAC_0_INCLUDE_TX_CSUM XPAR_PLB_TEMAC_0_INCLUDE_TX_CSUM
#endif
#ifndef XPAR_TEMAC_0_INCLUDE_RX_CSUM
#define XPAR_TEMAC_0_INCLUDE_RX_CSUM XPAR_PLB_TEMAC_0_INCLUDE_RX_CSUM
#endif
#else
#define XPAR_SYSTEM_INTC_TEMAC_0_IP2INTC_IRPT_INTR XPAR_INTC_SYSTEM_OCM_TEMAC_CNTLR_FIFO_INT_INTR
#define XPAR_TEMAC_0_DEVICE_ID 0
#define XPAR_TEMAC_0_BASEADDR 0xF2000000
#define XPAR_TEMAC_0_HIGHADDR 0xF2FFFFFF
#endif

#else
  /* Add other board xparameter includes here before the #else */
  #error No xparameters_*.h file included
#endif

#ifdef CONFIG_SUZAKU_V
#ifndef XPAR_INTC_0_BASEADDR
#define XPAR_INTC_0_BASEADDR XPAR_INTC_SINGLE_BASEADDR
#endif
#ifndef XPAR_INTC_0_KIND_OF_INTR
#define XPAR_INTC_0_KIND_OF_INTR XPAR_SYSTEM_INTC_KIND_OF_INTR
#endif
#ifndef XPAR_GPIO_SYSTEM_BASEADDR
#define XPAR_GPIO_SYSTEM_BASEADDR XPAR_OPB_GPIO_0_BASEADDR
#endif
#ifndef XPAR_GPIO_SYSTEM_HIGHADDR
#define XPAR_GPIO_SYSTEM_HIGHADDR XPAR_OPB_GPIO_0_HIGHADDR
#endif
#ifndef XPAR_GPIO_LED_BASEADDR
#define XPAR_GPIO_LED_BASEADDR XPAR_LED_GPIO_BASEADDR
#endif
#ifndef XPAR_GPIO_LED_HIGHADDR
#define XPAR_GPIO_LED_HIGHADDR XPAR_LED_GPIO_HIGHADDR
#endif
#ifndef XPAR_SPI_0_BASEADDR
#ifdef  XPAR_SPI_FLASH_BASEADDR
#define XPAR_SPI_0_BASEADDR XPAR_SPI_FLASH_BASEADDR
#else
#define XPAR_SPI_0_BASEADDR XPAR_SPI_CNTLR_MEM0_BASEADDR
#endif
#endif
#ifndef XPAR_SPI_0_HIGHADDR
#ifdef  XPAR_SPI_FLASH_HIGHADDR
#define XPAR_SPI_0_HIGHADDR XPAR_SPI_FLASH_HIGHADDR
#else
#define XPAR_SPI_0_HIGHADDR XPAR_SPI_CNTLR_MEM0_HIGHADDR
#endif
#endif
#ifndef XPAR_CONSOLE_UART_BASEADDR
#define XPAR_CONSOLE_UART_BASEADDR XPAR_UART_CONSOLE_BASEADDR
#endif
#ifndef XPAR_CONSOLE_UART_HIGHADDR
#define XPAR_CONSOLE_UART_HIGHADDR XPAR_UART_CONSOLE_HIGHADDR
#endif
#ifndef XPAR_SYSTEM_INTC_CONSOLE_UART_INTERRUPT_INTR
#define XPAR_SYSTEM_INTC_CONSOLE_UART_INTERRUPT_INTR XPAR_INTC_SYSTEM_UART_CONSOLE_INTERRUPT_INTR
#endif
#ifndef XPAR_OPB_UARTLITE_0_BASEADDR
#define XPAR_OPB_UARTLITE_0_BASEADDR XPAR_SIL_UART_CONSOLE_BASEADDR
#endif
#ifndef XPAR_OPB_UARTLITE_0_HIGHADDR
#define XPAR_OPB_UARTLITE_0_HIGHADDR XPAR_SIL_UART_CONSOLE_HIGHADDR
#endif
#ifndef XPAR_SYSTEM_INTC_OPB_UARTLITE_0_INTERRUPT_INTR
#define XPAR_SYSTEM_INTC_OPB_UARTLITE_0_INTERRUPT_INTR XPAR_INTC_SYSTEM_SIL_UART_CONSOLE_INTERRUPT_INTR
#endif
#ifndef XPAR_SID_CNTLR_MEM0_BASEADDR
#define XPAR_SID_CNTLR_MEM0_BASEADDR XPAR_OPB_SID00_0_AR0_BASEADDR
#endif
#ifndef XPAR_SID_CNTLR_MEM0_HIGHADDR
#define XPAR_SID_CNTLR_MEM0_HIGHADDR XPAR_OPB_SID00_0_AR0_HIGHADDR
#endif
#ifndef XPAR_INTC_SYSTEM_SID_CNTLR_SID_INTR_INTR
#define XPAR_INTC_SYSTEM_SID_CNTLR_SID_INTR_INTR XPAR_SYSTEM_INTC_OPB_SID00_0_OPB_INTERRUPT_INTR
#endif
#ifndef XPAR_SIL_CNTLR_BASEADDR
#define XPAR_SIL_CNTLR_BASEADDR XPAR_OPB_SIL00_0_BASEADDR
#endif
#ifndef XPAR_SIL_CNTLR_HIGHADDR
#define XPAR_SIL_CNTLR_HIGHADDR XPAR_OPB_SIL00_0_HIGHADDR
#endif
#endif

#ifndef SERIAL_PORT_DFNS
  /* zImage serial port definitions */
  #define RS_TABLE_SIZE 1
  #define SERIAL_PORT_DFNS {						\
	.baud_base	 = XPAR_UARTNS550_0_CLOCK_FREQ_HZ/16,		\
	.irq		 = XPAR_INTC_0_UARTNS550_0_VEC_ID,		\
	.flags		 = ASYNC_BOOT_AUTOCONF,				\
	.iomem_base	 = (u8 *)XPAR_UARTNS550_0_BASEADDR + 3,		\
	.iomem_reg_shift = 2,						\
	.io_type	 = SERIAL_IO_MEM,				\
  },
#endif
