#ifndef _MTD_SPI_PROBE_H_
#define _MTD_SPI_PROBE_H_

#define ID_MASK         0xffff

#define MANUFACTURER_ST 0x0020
#define M25P64          0x2017

#define SIZE_64KiB      0x10000
#define SIZE_8MiB       0x800000

struct spi_flash_info {
	const u16 mfr_id;
	const u16 dev_id;
	const u16 extra_id;
	const char *name;
	const int DeviceSize;
	const int EraseSize;
};

struct spi_chip_info {
	const struct spi_flash_info *flash;
	void (*destroy)(struct spi_chip_info *chip_info);

	u32 (*read)(u32 from, u32 to, u32 size);
	u32 (*write)(u32 from, u32 to, u32 size);
	int (*erase)(u32 addr);
};

#endif /* _MTD_SPI_PROBE_H_ */
