
#if !defined(_SMC911X_ARMADILLO5X0_H_)
#define _SMC911X_ARMADILLO5X0_H_

//#define SMC_USE_DMA		0
#if defined(REVA)
#define SMC_USE_16BIT		1
#define SMC_USE_32BIT		0
#else
#define SMC_USE_16BIT		0
#define SMC_USE_32BIT		1
#endif


#if defined(SMC_USE_DMA)

#include <linux/dma-mapping.h>
#include <asm/dma.h>

static u32 *buf1;
static u32 *buf2;
static mxc_dma_requestbuf_t dma_request;
static void
test_handler(int channel, void *data)
{
  int i;
   printk("%s()\n", __FUNCTION__);

   for(i=0;i<8;i++){
     printk("1[%d]: %08x\n", i, buf1[i]);
   }
   for(i=0;i<8;i++){
     printk("2[%d]: %08x\n", i, buf2[i]);
   }
   mxc_dma_disable(channel);
}

#include <asm/arch/dma.h>
static int
SMC_DMA_REQUEST(struct net_device *dev, void *handler)
{
  int channel = 0;//MXC_DMA_MEMORY;
  int ret;

  printk("%s()\n", __FUNCTION__);

  channel = mxc_dma_request(MXC_DMA_MEMORY, dev->name);
  if (channel < 0) {
    printk("failed dma_request\n");
  }
  printk("dma_channel: %d\n", channel);

  if(0){//test
    dma_channel_params *param;
    //memset(&param, 0, sizeof(param));
    param = mxc_sdma_get_channel_params(MXC_DMA_MEMORY);
    if(param < 0)
      printk("failed get ch param\n");

    param->watermark_level = 16;
    param->per_address = 0xb2000000 + 0x64;
    param->peripheral_type = EXT;
    param->transfer_type = per_2_emi;
    param->event_id=0;
    param->bd_number = 0;
    param->word_size = TRANSFER_16BIT;
    mxc_dma_setup_channel(channel, param);
  }


  /*@t*/{//test
    int i;
    //mxc_dma_requestbuf_t dma_request;
    //mxc_dma_callback_set(channel, handler, 0);
    mxc_dma_callback_set(channel, test_handler, 0);

    buf1 = kzalloc(4*256, GFP_DMA);
    buf2 = kzalloc(4*256, GFP_DMA);
    for(i=0;i<256;i++) buf1[i] = i+1;

    memset(buf2, 0, 4*256);
    buf2[0] = 0x5555aaaa;
    buf1[0] = 0xaaaa5555;
    memset(&dma_request, 0, sizeof(mxc_dma_requestbuf_t));
    //dma_request.src_addr = (dma_addr_t)buf1;
    //dma_request.src_addr = (dma_addr_t)dma_map_single(NULL, buf1, 1024, DMA_TO_DEVICE);
    dma_request.dst_addr = (dma_addr_t)dma_map_single(NULL,buf2 , 1024, DMA_FROM_DEVICE);

    //dma_request.dst_addr = (dma_addr_t)__pa(buf2);
    //dma_request.src_addr = (dma_addr_t)dev->base_addr/*0xb2000000*/ + 0x64;
    /*ok*/dma_request.src_addr = (dma_addr_t)(0xb2000000 + 0x64);
    //dma_request.src_addr = (dma_addr_t)(__pa(buf1));
    //dma_request.dst_addr = (dma_addr_t)dma_map_single(NULL, buf2, 1024, DMA_FROM_DEVICE);
    dma_request.num_of_bytes = 1024;

    //ret = mxc_dma_config(channel, &dma_request, 1, MXC_DMA_MODE_WRITE);
    ret = mxc_dma_config(channel, &dma_request, 1, MXC_DMA_MODE_READ);
    printk("dma_config ret : %d\n", ret);

    mxc_dma_enable(channel);

  }
  
  return channel;
}

static int
SMC_DMA_FREE(struct net_device *dev, int channel)
{
  printk("%s() channel: %d\n", __FUNCTION__, channel);
  mxc_dma_free(channel);

  kfree(buf1);
  kfree(buf2);
  return 0;
}

static int
SMC_DMA_ACK_IRQ(struct net_device *dev, int channel)
{
  printk("%s()\n", __FUNCTION__);
  return 0;
}

#endif /* SMC_USE_DMA */

#endif
