/*
 * include/asm-ppc/suzaku_sid.h - SUZAKU I/O Board: AD Module (SID00-U00) Driver
 *
 * Copyright (C) 2006-2008 Atmark Techno, Inc.
 * Chris McHarg <chris (at) atmark-techno.com>
 * Masahir Hanada <hanada (at) atmark-techno.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __PPC_SID_H
#define __PPC_SID_H

/*
 * SID Major Number
 */
#define SID_MAJOR		74

/*
 * IOCTR Commands
 */
#define SID_IOC_MAGIC		's'
#define SID_IOC_RESET		_IO(SID_IOC_MAGIC, 0)
#define SID_IOC_SET_FREQ	_IOW(SID_IOC_MAGIC, 1, int)
#define SID_IOC_GET_CHANNELS	_IOR(SID_IOC_MAGIC, 2, int)
#define SID_IOC_GET_RESOLUTION	_IOR(SID_IOC_MAGIC, 3, int)
#define SID_IOC_GET_OVERRUN	_IOR(SID_IOC_MAGIC, 4, int)

#endif /* __PPC_SID_H */
